/*
 * Copyright (C) 2008 Pleyo.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Pleyo nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PLEYO AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL PLEYO OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include "config.h"
#include "DragData.h"

#include "Clipboard.h"
#include "Document.h"
#include "DocumentFragment.h"

namespace WKAL {

bool DragData::canSmartReplace() const
{
    NotImplemented();
    return false;
}

bool DragData::containsColor() const
{
    NotImplemented();
    return false;
}

bool DragData::containsFiles() const
{
    NotImplemented();
    return false;
}

void DragData::asFilenames(Vector<String>& result) const
{
    NotImplemented();
}

bool DragData::containsPlainText() const
{
    NotImplemented();
    return false;
}

String DragData::asPlainText() const
{
    NotImplemented();
    return String();
}

Color DragData::asColor() const
{
    NotImplemented();
    return Color();
}

PassRefPtr<Clipboard> DragData::createClipboard(ClipboardAccessPolicy) const
{
    NotImplemented();
    return 0;
}

bool DragData::containsCompatibleContent() const
{
    NotImplemented();
    return false;
}

bool DragData::containsURL() const
{
    NotImplemented();
    return false;
}

String DragData::asURL(String* title) const
{
    NotImplemented();
    return String();
}


PassRefPtr<DocumentFragment> DragData::asFragment(Document*) const
{
    NotImplemented();
    return 0;
}

}
