/*
 * Copyright (C) 2008 Pleyo.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 * 1.  Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 * 2.  Redistributions in binary form must reproduce the above copyright
 *     notice, this list of conditions and the following disclaimer in the
 *     documentation and/or other materials provided with the distribution.
 * 3.  Neither the name of Pleyo nor the names of
 *     its contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY PLEYO AND ITS CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED. IN NO EVENT SHALL PLEYO OR ITS CONTRIBUTORS BE LIABLE FOR ANY
 * DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef BALType_h
#define BALType_h

struct FT_FaceRec_;
struct _FcPattern;

namespace WKAL {
    class FloatSize;
}

typedef FT_FaceRec_ BalFontFace;
typedef void BalFont;
typedef struct _FcPattern BalPattern;
typedef void BalScaledFont;
typedef void BalDrawable;
typedef IDirectFBSurface BalSurface;
typedef void BalMenuItem;
typedef IDirectFBSurface BalMenu;
typedef void BalClipboard;
typedef void BalTargetList;
typedef void BalAdjustment;
typedef void BalContainer;
typedef void BalPixbuf;
typedef struct _BalMatrix{double m11; double m12; double m13; double m14;
                          double m21; double m22; double m23; double m24;
                          double m31; double m32; double m33; double m34;
                          double m41; double m42; double m43; double m44;} BalMatrix;

typedef BalWidget* PlatformWidget;

#if !PLATFORM(DFB_CAIRO)
typedef IDirectFBSurface PlatformGraphicsContext;
typedef void* PlatformPatternPtr;
#endif

namespace WKAL {

#if !PLATFORM(DFB_CAIRO)
    typedef void* PlatformGradient;
    typedef void* PlatformPath;
#endif
    typedef IDirectFBSurface* PlatformCursor;

    typedef DFBColor BalColor;
    typedef void* DragImageRef;
    typedef void* DragDataRef;
    typedef unsigned short GlyphBufferGlyph;
    typedef WKAL::FloatSize GlyphBufferAdvance;
    typedef void* PlatformCursorHandle;
}

#endif
