#ifndef _DEBUG_PRINTF_H__
#define _DEBUG_PRINTF_H__

#if 0
#include <stdlib.h>
#include <stdio.h>
#include <assert.h>


#define D_PRINTF(x, ...) do {                                        \
    printf("[%s] %s %s %d : ", #x, __FILE__, __FUNCTION__, __LINE__); \
    printf(__VA_ARGS__);                                            \
}while(0)

#define D_INFO(...)     D_PRINTF(INFO, __VA_ARGS__)
#define D_WARN(...)     D_PRINTF(WARN, __VA_ARGS__)
#define D_ERROR(...)    do{D_PRINTF(ERROR, __VA_ARGS__); assert(0);}while(0)
#define D_ASSERT(...)   do{assert(__VA_ARGS__);}while(0)

#else

#define D_PRINTF(x, ...) do{}while(0)
#define D_INFO(...) do{}while(0)
#define D_WARN(...) do{}while(0)
#define D_ERROR(...) do{}while(0)
#define D_ASSERT(...) do{}while(0)

#endif


#endif //_DEBUG_PRTINF_H__
