/* 
 * log.h: define HOW to log
 * by ted.lu
 */

#ifndef _MY_LOG_H_
#define _MY_LOG_H_

#include <stdarg.h>
#include <string.h>

void _log(const char *fmt, ...);

#if 1//def DEBUG
	#define LOG(fmt, args...)  _log( "[log][uws][%s:%d:%s] "fmt"\n" , __FILE__, __LINE__, __FUNCTION__, ##args)
	#define ERROR(fmt, args...)  _log( "[error][uws][%s:%d:%s] "fmt"\n" , __FILE__, __LINE__, __FUNCTION__, ##args)
#else
	#define LOG(fmt, args...)  
	#define ERROR(fmt, args...)
#endif

#endif //_MY_LOG_H_
