#ifndef __ATVWebDownload_H__
#define __ATVWebDownload_H__

#include <wtf/Vector.h>
#include <wtf/Noncopyable.h>
#include <wtf/RefPtr.h>
#include <PlatformString.h>
#include <NotImplemented.h>
#include <ResourceError.h>
#include <ResourceHandle.h>
#include <ResourceRequest.h>
#include <ResourceHandleClient.h>
#include <ResourceResponse.h>
#include <WebKitATV.h>
#include <WebView.h>

using namespace WebCore;

class ATVWebDownload : public Noncopyable, ResourceHandleClient {
public:
    //interface for plugin
    static ATVWebDownload* getInstance();

public:
    ATVWebDownload(WebView* webView);
    virtual ~ATVWebDownload();

    virtual void startDownload(const char* url, lpDownloadCallbackFunc callback, void* ctx = NULL);
    virtual void startDownload(ResourceHandle*, const ResourceRequest*, const ResourceResponse*);
    virtual void stopDownload();

    inline WebView* webView() { return mWebView; }

    //interface of ResourceHandleClient
    virtual void didStart();
    virtual void didReceiveResponse(ResourceHandle*, const ResourceResponse&);
    virtual void didReceiveData(ResourceHandle*, const char*, int, int);
    virtual void didFinishLoading(ResourceHandle*);
    virtual void didFail(ResourceHandle*, const ResourceError&);
    virtual void wasBlocked(ResourceHandle*);
    virtual void cannotShowURL(ResourceHandle*);
    
private:
    WebView* mWebView;

    RefPtr<WebCore::ResourceHandle> mHandle;
    Vector<unsigned char> mData;

    lpDownloadCallbackFunc mCallback;
    void *mContext;
};

#endif  //__ATVWebDownload_H__

