#ifndef __WEBKIT_ATV_H__
#define __WEBKIT_ATV_H__

#ifndef WEBKIT_ATV_API
    #define WEBKIT_ATV_API __attribute__((visibility("default")))
#endif

#ifdef __cplusplus
extern "C" {
#endif //__cplusplus

typedef int (*lpDownloadCallbackFunc)(void* ctx, void* metaData, unsigned long length);

/**
 *  Ask Browser start download a meta file.
 */
WEBKIT_ATV_API int StartDownloadCPC(const char* url, lpDownloadCallbackFunc callback, void* ctx);

/**
 *  Ask Browser to cancel download a meta file.
 */
WEBKIT_ATV_API int StopDownloadCPC();

/**
 *  Browser Display Start
 *  parm URL : Start URL
 *  return : 0 Success, -1 Error.
 */
WEBKIT_ATV_API int StartBrowser(const char* URL);

/**
 * Browser Display Stop
 * return : 0 Success, -1 Error.
 */
WEBKIT_ATV_API int StopBrowser(void);


#ifdef __cplusplus
}
#endif //__cplusplus


#endif//__WEBKIT_ATV_H__

