#ifndef WEBCOOKIEJAR_H
#define WEBCOOKIEJAR_H

#include <WebKitTypes.h>
#include <string>
#include <vector>

class WebCookieJarPrivate;

class WEBKIT_OWB_API WebCookieJar {
public:
    WebCookieJar();
    virtual ~WebCookieJar();

    virtual void setCookies(const std::string& url, const std::string& cookies);
    virtual std::string cookies(const std::string& url);

    bool isEnabled() const;
    void setEnabled(bool enabled);

    static WebCookieJar* webCookieJar();

    void copyKeysToVector(std::vector<std::string>& keys);
    void clear();	

private:
    WebCookieJarPrivate* d;
};

#endif//WEBCOOKIEJAR_H

