#ifndef __WebView_Delegate_H__
#define __WebView_Delegate_H__

class WebView;

class WebViewDelegate {
public:
    virtual ~WebViewDelegate() {}

	virtual void displaySoftKeyboard(WebView* view, const int x = -1, const int y = -1, const int w = -1, const int h = -1) = 0;
	
    /**
     *  @param isSecret whether this input is password
     *  @param x the x posion where the softkeyboard should show.
     *  @param y the y posion where the softkeyboard should show.
     */
    virtual const char* displaySoftKeyboard(WebView* view, const char* initText, const bool isSecret = false, const int x = -1, const int y = -1) = 0;
    
    /**
     *  hide the softkeyboard
     */
    virtual void hideSoftKeyboard(WebView* view) = 0;

    /**
     * hover over link : call when mouse over link
     */
    virtual void hoverOverLink(WebView*, const char*, const char*) = 0;

    /**
     * set status bar : call when status change
     */
    virtual void setStatusBarText(WebView*, const char*) = 0;

    /**
     * display a message box to allow user interrupt current JavaScript execute
     */
    virtual bool shouldInterruptJavaScript() = 0;
};

#endif  //__Soft_Keyboard_Delegate_H__

