
#include "Fl_WebViewWindow.h"

using namespace WebCore;

Fl_WebViewWindow::Fl_WebViewWindow(int w, int h)
    : Fl_Window(w, h, "VA_WEBKIT Browser")
    , mWebView(NULL)
{ 
    border(0);
}

Fl_WebViewWindow::Fl_WebViewWindow(int x, int y, int w, int h)
    : Fl_Window(x, y, w, h, "VA_WEBKIT Browser")
    , mWebView(0)
{
    border(0);
}

Fl_WebViewWindow::~Fl_WebViewWindow()
{
}

void Fl_WebViewWindow::draw()
{
    BalEventExpose event;

    //Fl_Window::draw();

    IDirectFBSurface* surface = reinterpret_cast<IDirectFBSurface*>(getClientSurface());

    /////////FIXME////////////////it voilate fltk
    if (surface && mWebView) {
        DFBRectangle dirtyRect = mWebView->dirtyRegion();
        BalEventExpose event;

        event.dirty.x1 = dirtyRect.x;
        event.dirty.y1 = dirtyRect.y;
        event.dirty.x2 = dirtyRect.x + dirtyRect.w - 1;
        event.dirty.y2 = dirtyRect.y + dirtyRect.h - 1;

        surface->SetClip(surface, &event.dirty);
        mWebView->setViewWindow(this);
        mWebView->onExpose(event);
        surface->Flip(surface, &event.dirty, DSFLIP_BLIT);
    }
}

int Fl_WebViewWindow::handle(int event)
{    
    /////////FIXME /////////////
    if (!fl_dfb_event || !mWebView)
        return Fl_Window::handle(event);

    //printf("%s : event = %d\n", __FUNCTION__, event);

    DFBEvent dfbevent;
    
    switch(event) {
    	case FL_FOCUS:
        case FL_UNFOCUS:
            return 1;
        case FL_PUSH:
            dfbevent = *fl_dfb_event;
            dfbevent.window.cx = Fl::event_x();
            dfbevent.window.cy = Fl::event_y();
            mWebView->onMouseButtonDown(dfbevent);
            return 1;
        case FL_RELEASE:
            dfbevent = *fl_dfb_event;
            dfbevent.window.cx = Fl::event_x();
            dfbevent.window.cy = Fl::event_y();
            mWebView->onMouseButtonUp(dfbevent);
            return 1;
        case FL_MOVE:
        case FL_DRAG:
            dfbevent = *fl_dfb_event;
            dfbevent.window.cx = Fl::event_x();
            dfbevent.window.cy = Fl::event_y();
            mWebView->onMouseMotion(dfbevent);
            return 1;

        case FL_SHORTCUT:
        case FL_KEYDOWN:
        	if (Fl::event_key() == FL_Home)
        		return 0;
            dfbevent = *fl_dfb_event;
            mWebView->onKeyDown(dfbevent);
            return 1;
        case FL_KEYUP:
        	if (Fl::event_key() == FL_Home)
        		return 0;
            dfbevent = *fl_dfb_event;
            mWebView->onKeyUp(dfbevent);
            return 1;

        default:
            return Fl_Window::handle(event);
    }
}

