#ifndef __FL_Digital_Clock_H__
#define __FL_Digital_Clock_H__

#include <FL/Fl_Box.H>
#include <time.h>

class Fl_Digital_Clock : public Fl_Box {
protected:
    virtual void draw();
    virtual int handle(int);

public:
    Fl_Digital_Clock(int x, int y, int w, int h, const char* l = 0, int level = 5);
    ~Fl_Digital_Clock();

    int level() const { return mLevel; }
    void setLevel(int level) { mLevel = level; }
    
    void setTime(time_t time);
    time_t time() const { return mCurrentTime; }

private:
    int mLevel;
    time_t mCurrentTime;
};

#endif//__FL_Digital_Clock_H__

