
#include <stdio.h>
#include <FL/fl_draw.H>
#include <FL/Fl_Window.H>

#include "Fl_GraphicButton.h"
#include "Fl_ImageCache.h"

Fl_GraphicButton::Fl_GraphicButton(int x, int y,int w, int h,const char* label,const char* inactiveImage,const char* activeImage)
	: Fl_Button(x, y, w, h,label)
{		
	m_pButton   = Fl_ImageCache::getInstance()->get(inactiveImage);
	m_pButton_H = Fl_ImageCache::getInstance()->get(activeImage);
	
	if(m_pButton)
		this->size(m_pButton->w(),m_pButton->h());
		 
	if(m_pButton == NULL || m_pButton_H == NULL)
		printf("Fl_GraphicButton Load image failed\n");	
}	

Fl_GraphicButton::~Fl_GraphicButton()
{	
	if(m_pButton != NULL)
		m_pButton->release();
	if(m_pButton_H != NULL)
		m_pButton_H->release();			
}	

void Fl_GraphicButton::draw()
{ 
	if(m_pButton == NULL && m_pButton_H == NULL)
		printf("Fl_GraphicButton::draw check image(loaded by Contructor) failed\n");
	
	fl_color(color());
	fl_rectf(x(), y(), w(), h());
	
	if(Fl::focus() == this){
		m_pButton_H->draw(x(), y());
	}	
	else{		
		m_pButton->draw(x(), y());
	}
    if (label())
        draw_label(x(), y(), w(), h(), FL_ALIGN_CENTER);    
}

