
#include <limits.h>
#include <stdlib.h>
#include <stdio.h>

#include "Fl_ImageCache.h"

Fl_ImageCache* Fl_ImageCache::s_instance = NULL;

Fl_ImageCache* Fl_ImageCache::getInstance()
{
    if (s_instance == NULL) {
        fl_register_images();
        s_instance = new Fl_ImageCache();
    }
    return s_instance;
}

Fl_Shared_Image* Fl_ImageCache::get(const char* imageFile, const int w, const int h)
{
    char realFile[PATH_MAX];
    
    if (!imageFile || !imageFile[0]) {
        return 0;
    }
    if (imageFile[0] != '/')
        snprintf(realFile, PATH_MAX, "%s/Resources/images/%s", getenv("VA_RUNTIME_ROOT"), imageFile);
    else
        snprintf(realFile, PATH_MAX, "%s", imageFile);
        
    Fl_Shared_Image *image = Fl_Shared_Image::get(realFile, w, h);
    if (!image)
        printf("failed to load image file %s\n", realFile);
    return image;
}

Fl_Shared_Image* Fl_ImageCache::find(const char* imageFile, const int w, const int h)
{
    char realFile[PATH_MAX];
    
    if (!imageFile || !imageFile[0]) {
        return 0;
    }
    if (imageFile[0] != '/')
        snprintf(realFile, PATH_MAX, "%s/Resources/images/%s", getenv("VA_RUNTIME_ROOT"), imageFile);
    else
        snprintf(realFile, PATH_MAX, "%s", imageFile);

    Fl_Shared_Image *image = Fl_Shared_Image::find(realFile, w, h);
    if (!image)
        printf("failed to find image file %s\n", realFile);
    return image;
}

