#ifndef _FL_InputKB_H
#define _FL_InputKB_H

#include <FL/Fl.H>
#include <FL/Fl_Input.H>

class Fl_InputKB  : public Fl_Input {
protected:
    virtual int handle(int);
    
public:
	Fl_InputKB(int x, int y, int w, int h, const char* label=0);
	~Fl_InputKB();

	void cutAsUTF8(int n);
	int moveCursorAsUTF8(int n);

	void move(int pos_x, int pos_y = -1);
	void setXLimit(int x);
	void insertAndAdjustSize(const char* t, int l=0);
	void cutAndAdjustSize(int n);
	void highlightLastCharacter();
	void updateCursorInfo();
	void setMaxWidth(int x);
private:
	int getPositionAsUTF8(int n);

	int mX;
	int mXLimit;
	int mMaxWidth;
};

#endif // _FL_InputKB_H