#ifndef __FL_MainMenu_H__
#define __FL_MainMenu_H__

#include <FL/Fl_Group.H>
#include <FL/Fl_Menu_Bar.H>
#include "Fl_GraphicButton.h"

#define ButtonArraySize 9

class Fl_MainMenu : public Fl_Group {
public:
    Fl_MainMenu(int x, int y, int w, int h, const char* label = 0);
    ~Fl_MainMenu();

public:
    
    void handleMenu();

    int popupMenu();

protected:
    int handle(int);

private:
    void updateMainMenu();
    void updateHistoryMenu();
    void updateBookmarkMenu();
    void updateSettingsMenu();
    //void handleHistoryMenu(Fl_Menu_Item*);
    //void handleBookmarkMenu(Fl_Menu_Item*);
    void prepareButtonMenu(int y);
private:
    bool mPopuping;
    Fl_GraphicButton* m_GButton[ButtonArraySize];
    Fl_Menu_Bar* m_advance;
};

#endif  //__FL_MainMenu_H__

