#ifndef __FL_MessageForm_H__
#define __FL_MessageForm_H__

#include <stdarg.h>
#include <FL/Fl_Window.H>

class Fl_Shared_Image;
class Fl_GraphicButton;
class Fl_Box;
class Fl_Widget;

class Fl_Message_Form : public Fl_Window {

public:
    Fl_Message_Form(int x, int y, int w, int h, const char* label = 0);
    ~Fl_Message_Form();

    void message(const char* fmt, va_list ap);
    void message(const char* fmt, ...);
    bool ask(const char* fmt, va_list ap);
    bool ask(const char* fmt, ...);

protected:
    virtual void draw();

private:
    int innards(const char* fmt, va_list ap, const char* yes, const char* no, const char* ok);

private:
    Fl_Box* mMessage;
    Fl_Box* mIcon;
    Fl_GraphicButton* mYes;
    Fl_GraphicButton* mNo;
    Fl_GraphicButton* mOK;
    Fl_Shared_Image* mBgImage;
    Fl_Shared_Image* mBangImage;
    Fl_Shared_Image* mIntegralImage;
    char mBuffer[1024];
};

#endif //__FL_MessageForm_H__

