
#include "History.h"
#include <algorithm>

/*
static History* sDefaultHistory = NULL;

History* History::defaultHistory()
{
    if (!sDefaultHistory)
        sDefaultHistory = new History();
    return sDefaultHistory;
}
*/

History::History()
    : mTitle()
    , mURL()
{
}

History::~History()
{
}

int History::countItems()
{
    return mTitle.size();
}

void History::itemAt(const int item, string& title, string& url)
{
    if (item < 0 || item >= countItems())
        return;
    title = mTitle[item];
    url  = mURL[item];
}

void History::removeItem(const int item)
{
    if (item < 0 || item >= countItems())
        return;
    mTitle.erase(mTitle.begin() + item);
    mURL.erase(mURL.begin() + item);
}

void History::removeAllItems()
{
    mTitle.clear();
    mURL.clear();
}

void History::addHistoryEntry(const string& url, const string& title)
{
    if (countItems() >= MAX_HISTORY_ITEMS) {
        mTitle.erase(mTitle.begin() + (MAX_HISTORY_ITEMS - 1));
        mURL.erase(mURL.begin() + (MAX_HISTORY_ITEMS - 1));
    }
    mTitle.insert(mTitle.begin(), title);
    mURL.insert(mURL.begin(), url);
}

bool History::historyContains(const string& url) const
{
    return std::find(mURL.begin(), mURL.end(), url) != mURL.end();
}


