#ifndef HISTORY_H
#define HISTORY_H

#include <WebHistoryInterface.h>
#include <vector>

using namespace std;

class History : public WebHistoryInterface {
public:    
    static const int MAX_HISTORY_ITEMS = 20;

public:
    History();
    ~History();

    void addHistoryEntry(const string& url, const string& title);
    bool historyContains(const string& url) const;

    //
    int countItems();
    void itemAt(const int item, string& title, string& url);
    void removeItem(const int item);
    void removeAllItems();

private:
    vector<string> mTitle;
    vector<string> mURL;
};

#endif//HISTORY_H

