#ifndef __MainJSAactionDelegate_H__
#define __MainJSAactionDelegate_H__

#include <WebKit.h>
#include <stdio.h>

#include <FL/Fl.H>
#include <FL/fl_ask.H>

class MainJSActionDelegate : public JSActionDelegate {

public:
    MainJSActionDelegate() { }
    ~MainJSActionDelegate() { }

    virtual void windowObjectClearNotification(WebFrame*, void*, void*)
    {
    }

    virtual void consoleMessage(WebFrame*, int line, const char *message)
    {
        printf("CONSOLE MESSAGE: line %d: %s\n", line, message);
    }

    virtual bool jsAlert(WebFrame *frame, const char *message)
    {
        //fl_alert(message);
        printf("JS ALERT: frame %p: %s\n", frame, message);        
        return true;
    }

    virtual bool jsConfirm(WebFrame *frame, const char *message)
    {
        //return fl_choice(message, "Yes", "No", 0L);
        printf("JS CONFIRM: frame %p: %s\n", frame, message);
        return false;
    }

    virtual bool jsPrompt(WebFrame *frame, const char *message, const char *defaultValue, char **value)
    {
        /*
         *  const char* input = fl_input(defaultValue, message);
         *  if (input) {
         *      strcpy(*value, input);
         *      return true;
         *  } else
         *      return false;
         */
        printf("JS PROMPT: frame %p: %s, defaultValue = %s\n", frame, message, defaultValue ? defaultValue : "null");
        return false;
    }
};

#endif  //__MainJSAactionDelegate_H__

