#ifndef __MainWebFrameLoadDelegate_H__
#define __MainWebFrameLoadDelegate_H__

#include <WebKit.h>
#include <stdio.h>

#include "IServiceFactory.h"

class MainWebFrameLoadDelegate : public WebFrameLoadDelegate {

public:
    MainWebFrameLoadDelegate()
    {
    }

    ~MainWebFrameLoadDelegate()
    {        
    }

    /**
     * windowObjectClearNotification
     */
    void windowObjectClearNotification(WebFrame*, void*, void*)
    {
    }

    /**
     * titleChange : call when the title change
     */
    void titleChange(WebFrame* frame, const char* title)
    {
        printf("titleChange: %s\n", title);   
        Fl_Box* titleBar = IServiceFactory::getInstance()->titleBar();
        if (!frame->parentFrame() && titleBar && title) {
            titleBar->copy_label(title);
        }
    }

    /**
     * didStartLoad : called when a frame starts loading
     */
    void didStartProvisionalLoad(WebFrame*)
    {
    }

    /**
     * didReceiveServerRedirectForProvisionalLoadForFrame: called when a server-side redirection occurs.
     */
    void didReceiveServerRedirectForProvisionalLoadForFrame(WebFrame*)
    {
    }

    /**
     * willPerformClientRedirectToURL: called when a client-side will occur.
     */
    virtual void willPerformClientRedirectToURL(WebFrame*, const char* url, double delaySeconds, double fireDate)
    {
    }

    /**
     * didCancelClientRedirectForFrame: called when a client-side redirection was cancelled before it occurred.
     */
    virtual void didCancelClientRedirectForFrame(WebFrame*)
    {
    }

    /**
     * didCommitLoad : called when a frame data source transitions from provisional state to committed
     */
    virtual void didCommitLoad(WebFrame*)
    {
    }

    /**
     * didFinishLoad : called when a frame has finished loading itself and its resources
     */
    virtual void didFinishLoad(WebFrame*)
    {
    }

    /**
     * didFailLoad : called if a frame loading failed
     */
    // FIXME: We should use a WebError argument once it is exported to third party application.
    virtual void didFailLoad(WebFrame*)
    {
    }

};

#endif  //__MainWebFrameLoadDelegate_H__

