
#include <WebKit.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <limits.h>

#include <FL/Fl_Window.H>
#include <FL/x.H>
#include "MainApplication.h"
#include "Fl_WebViewWindow.h"
#ifdef VA_PLATFORM_BDH
//#include <sharemem.h>
#include <keycode.h>
//#include <sysapi.h>
//#include <sysmsg.h>
//#include <handler.h>
//#include <lhandheader.h>
//#include <ytbheader.h>
//#include <outdtype.h>
#endif //VA_PLATFORM_BDH

static void init_runtime_environment()
{
    char path[PATH_MAX];
    char *p;

    int len = readlink("/proc/self/exe", path, sizeof(path) - 1);
    path[len] = 0;
    p = strrchr(path, '/');
    if (p == NULL)
        goto badpath;
    p = p - 4;
    if (p >= path && strncmp(p, "/bin/", 5) == 0) {
        if (p == path)
            p[1] = 0;
        else
            p[0] = 0;
    } else {
        goto badpath;
    }
    setenv("VA_RUNTIME_ROOT", path, 0);
    snprintf(path, PATH_MAX, "%s/lib/plugins", getenv("VA_RUNTIME_ROOT"));
    setenv("VA_WEBKIT_PLUGIN_PATH", path, 0);
    fprintf(stderr, "!!!VA_RUNTIME_ROOT = %s!!!\n", getenv("VA_RUNTIME_ROOT"));
    fprintf(stderr, "!!!VA_WEBKIT_PLUGIN_PATH = %s!!!\n", getenv("VA_WEBKIT_PLUGIN_PATH"));

    return;
badpath:
    fprintf(stderr, "invalid path %s \n", path);
    abort();
}

#ifdef VA_PLATFORM_BDH
extern "C" int user_initialize();
extern "C" int YtbEventNotifyExit(void);
extern "C" int YtbEventNotifyStartUpFin(void);
#endif

/*****************************************************************************/
/* ABST. :                                                                   */
/* FUNC. : YtbEventNotifyExit                                                */
/* ARGS  :                                                                   */
/* RETURN:                                                                   */
/* DESC. :                                                                   */
/* AUTHOR:                                                                   */
/* DATE  : 10.01.18                                                          */
/*****************************************************************************/
//int YtbEventNotifyExit(void)
//{
//	TAKE_SEM_YTB_EVT;
//	eSysSendMessage( QID_UIM, msgYtbNotifyUimExitYoutube, NULL, 0, S_WAITFOREVER);
//	GIVE_SEM_YTB_EVT;
//	eDbgPrintf(0, "[YTBEVT] send msgYtbNotifyUimExitYoutube \n" );
//	return (1);
//}
/*****************************************************************************/
/* ABST. :                                                                   */
/* FUNC. : YtbEventNotifyStartUpFin                                          */
/* ARGS  :                                                                   */
/* RETURN:                                                                   */
/* DESC. :                                                                   */
/* AUTHOR:                                                                   */
/* DATE  : 10.01.18                                                          */
/*****************************************************************************/
//int YtbEventNotifyStartUpFin(void)
//{
//	TAKE_SEM_YTB_EVT;
//    eSysSendMessage(QID_APPLI_LOADER, msgYoutubeNotifyAplYoutubeReady, NULL, 0, S_WAITFOREVER);
//	GIVE_SEM_YTB_EVT;
//   eDbgPrintf(0, "[YTBEVT] send msgYoutubeNotifyAplYoutubeReady\n");
//	return (1);
//}

__attribute__((visibility("default")))
int main (int argc, char* argv[])
{
#ifdef VA_PLATFORM_BDH
    //bdhInit(argc, argv);
    printf("@@@@ Begin to invoke user_initialize.\n");
    user_initialize();
    printf("@@@@ Begin to invoke user_initialize.\n");
    printf("@@@@ Begin to invoke YtbEventNotifyStartUpFin.\n");
    YtbEventNotifyStartUpFin();
    printf("@@@@ End invoking YtbEventNotifyStartUpFin.\n");
#endif
	int iRet = -1;
	fl_open_display();
	{
    init_runtime_environment();

    MainApplication app(argc, argv);
#if 0    
    char* uri = (char*) (argc > 1 ? argv[1] : "http://www.google.com/");

    app.webViewWindow()->webView()->mainFrame()->loadURL(uri);    
    app.mainWindow()->show();
    Fl::focus(app.webViewWindow());
#endif    
     
    //Fl_WebViewWindow* v = new Fl_WebViewWindow(0, 0, 300, 200);
    //v->show();
    //v->webView()->mainFrame()->loadURL(uri);

    iRet = app.run();
	}
	fl_close_display();
	
#ifdef VA_PLATFORM_BDH
	printf("@@@@ Begin to invoke YtbEventNotifyExit.\n");
    YtbEventNotifyExit();
    printf("@@@@ End invoking YtbEventNotifyExit.\n");
#endif

	return iRet;
}

