#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <WebKitATV.h>

#ifdef VA_PLATFORM_BDH
extern "C" int user_initialize(void);
#endif

static void help()
{
    printf("*****************************\n");
    printf("Help: show this\n");
    printf("StartBrowser <URL>: Start ATV Browser to access URL\n");
    printf("StopBrowser: Stop ATV Browser\n");
    printf("Quit: exit program\n");
    printf("*****************************\n");
}

int main(int argc, char* argv[])
{
#ifdef VA_PLATFORM_BDH
    user_initialize();
    usleep(1000 * 1000 * 5);
#endif
    
    if (argc > 1) {
        FILE* websites_list = fopen(argv[1], "r");
        char url[1024];
        int wait;
        int ret;
        int count = 0;

        while(true) {
            url[0] = 0;
            wait = 15;
            ret = fscanf(websites_list, "%s %d", url, &wait);
            if (ret == EOF) {
                StopBrowser();
                break;
            }
            printf("%s %d\n", url, wait);
            if (ret < 1)
                continue;
            if (url[0] == '#')
                continue;
            if (wait <= 0)
                wait = 10;
            if (wait >= 100)
                wait = 100;
            StartBrowser(url);
            count++;
            sleep(wait);
        }
        fclose(websites_list);
    } else {
        char input[1024];

        help();
        while(1) {
            printf("\n>>");
            //fgets(input, sizeof(input), stdin);
            gets(input);
            //puts(input);
            if (!strcmp(input, "Help")) {
                help();
            } else if (strstr(input, "StartBrowser ") == input) {
                char* url = &input[13];
                StartBrowser(url);
            } else if (!strcmp(input, "StopBrowser")) {
                StopBrowser();
            } else if (!strcmp(input, "Quit")) {
                StopBrowser();
                return 0;
            }
        }
    }
    return 0;
}

