if(USE_GRAPHICS STREQUAL "GTK")
    pkg_check_modules(CAIRO REQUIRED cairo>=1.4)
    pkg_check_modules(GTK REQUIRED gtk+-2.0>=2.8)
    pkg_check_modules(GAIL REQUIRED gail)
    set(GRAPHICS_INCLUDE_DIRS ${GTK_INCLUDE_DIRS} ${GAIL_INCLUDE_DIRS})
    set(GRAPHICS_LIBRARIES ${GTK_LDFLAGS} ${GAIL_LDFLAGS})

    set(USE_GRAPHICS_GTK TRUE)
    mark_as_advanced(USE_GRAPHICS_GTK)

    set(REQUIREMENT "gtk+-2.0 >= 2.8")
endif(USE_GRAPHICS STREQUAL "GTK")

if(USE_GRAPHICS STREQUAL "QT")
    FIND_PACKAGE(Qt4)
    pkg_check_modules(QTGRAPHIC REQUIRED QtGui)
    set(GRAPHICS_INCLUDE_DIRS ${QTGRAPHIC_INCLUDE_DIRS})
    set(GRAPHICS_LIBRARIES ${QTGRAPHIC_LDFLAGS})

    set(USE_GRAPHICS_QT TRUE)
    mark_as_advanced(USE_GRAPHICS_QT)
endif(USE_GRAPHICS STREQUAL "QT")

if(USE_GRAPHICS STREQUAL "SDL")
	LINK_DIRECTORIES(${VA_DFB_LIBRARY_DIR})

    set(GRAPHICS_INCLUDE_DIRS ${VA_SDL_INCLUDE_DIR} ${VA_SDLGFX_INCLUDE_DIR})
    set(GRAPHICS_LIBRARIES ${VA_SDL_LIBS} ${VA_SDLGFX_LIBS})

    set(USE_GRAPHICS_SDL TRUE)
    mark_as_advanced(USE_GRAPHICS_SDL)

    set(REQUIREMENT "sdl >= 1.2.10")
endif(USE_GRAPHICS STREQUAL "SDL")

if(USE_GRAPHICS STREQUAL "DFB")
    link_directories(${VA_DFB_LIBRARY_DIR})

    set(GRAPHICS_INCLUDE_DIRS ${VA_DFB_INCLUDE_DIR} ${VA_FLTK_INCLUDE_DIR})
    set(GRAPHICS_LIBRARIES ${VA_DFB_LIBS} ${VA_FLTK_LIBS})

    set(USE_GRAPHICS_DFB TRUE)

    if(ENABLE_CAIRO_DFB)
      set(GRAPHICS_INCLUDE_DIRS ${GRAPHICS_INCLUDE_DIRS} ${VA_CAIRO_INCLUDE_DIR})
      set(GRAPHICS_LIBRARIES ${GRAPHICS_LIBRARIES} ${VA_CAIRO_LIBS})
    endif(ENABLE_CAIRO_DFB)

endif(USE_GRAPHICS STREQUAL "DFB")
